import { ChangeDetectorRef, Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { NgbDate, NgbModal } from '@ng-bootstrap/ng-bootstrap';
import { ExcelReportService } from 'src/app/service/excel-report.service';
import * as FileSaver from 'file-saver';
import { IDataOptions } from '@syncfusion/ej2-angular-pivotview';

export interface ModalDetail {
    text: { cardHead: string, search: string[], tableHead: string[] }
}
@Component({
    selector: 'app-excel-report',
    templateUrl: './excel-report.component.html',
    styleUrls: ['./excel-report.component.scss']
})
export class ExcelReportComponent implements OnInit {
    // สำหรับ Grid
    public gridData = [
        { id: 1, name: 'Alice', age: 28 },
        { id: 2, name: 'Bob', age: 32 },
        { id: 3, name: 'Charlie', age: 25 },
        { id: 4, name: 'David', age: 45 },
        { id: 5, name: 'Eva', age: 38 },
        { id: 6, name: 'Frank', age: 40 }
    ];

    // สำหรับ Pivot
    public pivotDataSource: IDataOptions = {
        dataSource: [
            { Product: 'Laptop', Region: 'North', Sales: 100 },
            { Product: 'Tablet', Region: 'South', Sales: 200 },
            { Product: 'Phone', Region: 'North', Sales: 150 },
            { Product: 'Laptop', Region: 'South', Sales: 120 },
        ],
        values: [{ name: 'Sales', caption: 'Sales Amount' }],
        rows: [{ name: 'Product' }],
        columns: [{ name: 'Region' }],
    };

    data = {
        "itemId": "3459",
        "templateId": "3011",
        "fileName": "BFET6T4QJ.xlsx",
        "tdesc": "FOR TEST OPTION ESS",
        "edesc": "FOR TEST OPTION ESS",
        "target": "mainFrame",
        "module": "EMPVIEW",
        "link": "../XLSOPTION.jsp?__xlsname=BFET6T4QJ.xlsx",
        "groups": "XLS01",
        "pages": "3459",
        "headerId": "",
        "display": "",
        "param": {
            "excelFile": "BFET6T4QJ.xlsx",
            "isDataGrid": false,
            "isDataPivot": false,
            "reportEngName": "FOR TEST OPTION ESS",
            "reportThaiName": "FOR TEST OPTION ESS",
            "variableName": "date1,date2,bu3_begin,bu3_end,date3,status,year1,salatype",
            "variableParam": "?fileName=BFET6T4QJ.xlsx&param=__varname=date1,date2,bu3_begin,bu3_end,date3,status,year1,salatype|__screen=XLSOPTION|__date1=04-03-2025|__date2=04-03-2025|__bu3_begin=|__bu3_end=xxxxxxxxxx|__date3=01-01-2024|__status=1.0|__year1=2025.0|__salatype=01",
            "variableSheet": {
                "bu3_begin": {
                    "label": "bu3 start",
                    "option": "mbu3help|__bu3_begin:mbu3.bu3id",
                    "table": "mbu3",
                    "type": "help",
                    "value": "",
                    "valueDefault": "",
                    "valueDetail": [
                        {
                            "tdesc": "NONE",
                            "edesc": "NONE",
                            "id": "00"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "1011"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "10111"
                        },
                        {
                            "tdesc": "GM/SMG/MG/AM [ Admin ]",
                            "edesc": "GM/SMG/MG/AM [ Admin ]",
                            "id": "1012"
                        },
                        {
                            "tdesc": "Chief,A-Chief [HR]",
                            "edesc": "Chief,A-Chief [HR]",
                            "id": "1013"
                        },
                        {
                            "tdesc": "HR",
                            "edesc": "HR",
                            "id": "1014"
                        },
                        {
                            "tdesc": "Interpretor",
                            "edesc": "Interpretor",
                            "id": "1015"
                        },
                        {
                            "tdesc": "Driver [ HR]",
                            "edesc": "Driver [ HR]",
                            "id": "1016"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist[Safety]",
                            "edesc": "S-MG,MG,AM,Specialist[Safety]",
                            "id": "1017"
                        },
                        {
                            "tdesc": "Chief,A-Chief [Safety]",
                            "edesc": "Chief,A-Chief [Safety]",
                            "id": "1018"
                        },
                        {
                            "tdesc": "Safety",
                            "edesc": "Safety",
                            "id": "1019"
                        },
                        {
                            "tdesc": "MG,AM,Specialist  [G.A./QCC,Training Center]",
                            "edesc": "MG,AM,Specialist  [G.A./QCC,Training Center]",
                            "id": "1020"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [G.A./QCC,Training Center]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [G.A./QCC,Training Center]",
                            "id": "1021"
                        },
                        {
                            "tdesc": "G.A./QCC,Training Center",
                            "edesc": "G.A./QCC,Training Center",
                            "id": "1022"
                        },
                        {
                            "tdesc": "Japanese  [ Cad  Design ]",
                            "edesc": "Japanese  [ Cad  Design ]",
                            "id": "1023"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [Cad  Design]",
                            "edesc": "MG,AM,Specialist [Cad  Design]",
                            "id": "1024"
                        },
                        {
                            "tdesc": "Chief,A-Chief, [Cad  Design]",
                            "edesc": "Chief,A-Chief, [Cad  Design]",
                            "id": "1025"
                        },
                        {
                            "tdesc": "CAD Design",
                            "edesc": "CAD Design",
                            "id": "1026"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist  [ Purchase ]",
                            "edesc": "S-MG,MG,AM,Specialist  [ Purchase ]",
                            "id": "1031"
                        },
                        {
                            "tdesc": "Chief,A-Chief [Purchase]",
                            "edesc": "Chief,A-Chief [Purchase]",
                            "id": "1032"
                        },
                        {
                            "tdesc": "Purchase",
                            "edesc": "Purchase",
                            "id": "1033"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [BOI./J-SOX]",
                            "edesc": "MG,AM,Specialist [BOI./J-SOX]",
                            "id": "1034"
                        },
                        {
                            "tdesc": "Chief,A-Chief [BOI./J-SOX]",
                            "edesc": "Chief,A-Chief [BOI./J-SOX]",
                            "id": "1035"
                        },
                        {
                            "tdesc": "BOI./J-SOX",
                            "edesc": "BOI./J-SOX",
                            "id": "1036"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ISO 14001]",
                            "edesc": "Chief,A-Chief [ISO 14001]",
                            "id": "1037"
                        },
                        {
                            "tdesc": "ISO 14001 , นิติกร",
                            "edesc": "ISO 14001 , Lawyer",
                            "id": "1038"
                        },
                        {
                            "tdesc": "AM,Senior  Specialist /Specialist[ Accounting ]",
                            "edesc": "AM,Senior  Specialist /Specialist[ Accounting ]",
                            "id": "1041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Accounting]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Accounting]",
                            "id": "1042"
                        },
                        {
                            "tdesc": "Account",
                            "edesc": "Account",
                            "id": "1043"
                        },
                        {
                            "tdesc": "ทดสอบ",
                            "edesc": "TEST",
                            "id": "123"
                        },
                        {
                            "tdesc": "Japanese  [ Sales ]",
                            "edesc": "Japanese  [ Sales ]",
                            "id": "2011"
                        },
                        {
                            "tdesc": "OO,GM,MG,AM,Specialist  [Sales]",
                            "edesc": "OO,,MG,AM,Specialist  [Sales]",
                            "id": "2012"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ Sales]",
                            "edesc": "Chief,A-Chief [ Sales]",
                            "id": "2013"
                        },
                        {
                            "tdesc": "SALES",
                            "edesc": "SALES",
                            "id": "2014"
                        },
                        {
                            "tdesc": "Driver [Sales]",
                            "edesc": "Driver [Sales]",
                            "id": "2015"
                        },
                        {
                            "tdesc": "Patrol Line",
                            "edesc": "Patrol Line",
                            "id": "300047"
                        },
                        {
                            "tdesc": "QCC. & NPS.",
                            "edesc": "QCC. & NPS.",
                            "id": "300049"
                        },
                        {
                            "tdesc": "Japanese [Engineer]",
                            "edesc": "Japanese [Engineer]",
                            "id": "3010"
                        },
                        {
                            "tdesc": "AM/Specialist [ Die Engineer ]",
                            "edesc": "AM/Specialist [ Die Engineer ]",
                            "id": "3011"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Die Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Die Engineer]",
                            "id": "3012"
                        },
                        {
                            "tdesc": "Die Engineer",
                            "edesc": "Die Engineer",
                            "id": "3013"
                        },
                        {
                            "tdesc": "MG/Specialist [Mold Engineer]",
                            "edesc": "MG/Specialist [Mold Engineer]",
                            "id": "3014"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Mold Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Mold Engineer]",
                            "id": "3015"
                        },
                        {
                            "tdesc": "Mold Engineer",
                            "edesc": "Mold Engineer",
                            "id": "3016"
                        },
                        {
                            "tdesc": "MG [IE Engineer]",
                            "edesc": "MG [IE Engineer]",
                            "id": "3020"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ IE Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ IE Engineer]",
                            "id": "3021"
                        },
                        {
                            "tdesc": "IE Engineer",
                            "edesc": "IE Engineer",
                            "id": "3022"
                        },
                        {
                            "tdesc": "OO,GM, MG [Sales Enginrre & APQP]",
                            "edesc": "OO,GM, MG [Sales Enginrre & APQP]",
                            "id": "3023"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ APQP.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ APQP.]",
                            "id": "3024"
                        },
                        {
                            "tdesc": "Sales Engineer & APQP",
                            "edesc": "Sales Engineer & APQP",
                            "id": "3025"
                        },
                        {
                            "tdesc": "Japanese [QA.]",
                            "edesc": "Japanese [QA.]",
                            "id": "3031"
                        },
                        {
                            "tdesc": "Part Service-2",
                            "edesc": "Part Service-2",
                            "id": "303108"
                        },
                        {
                            "tdesc": "Non Finishing-2",
                            "edesc": "Non Finishing-2",
                            "id": "303110"
                        },
                        {
                            "tdesc": "IE and Kaizen team - 2",
                            "edesc": "IE and Kaizen team - 2",
                            "id": "303117"
                        },
                        {
                            "tdesc": "Senior MG,  AM, Specialist [QA./TS.16949]",
                            "edesc": "Senior MG,  AM, Specialist [QA./TS.16949]",
                            "id": "3032"
                        },
                        {
                            "tdesc": "Production standard cost center (PSC)",
                            "edesc": "Production standard cost center (PSC)",
                            "id": "303201"
                        },
                        {
                            "tdesc": "Fix asset Control",
                            "edesc": "Fix asset Control",
                            "id": "303202"
                        },
                        {
                            "tdesc": "New model lunch up schedule (Lead APQP) Eguiment & Tool Purchase Gr.",
                            "edesc": "New model lunch up schedule (Lead APQP) Eguiment & Tool Purchase Gr.",
                            "id": "303203"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ QA Incharge ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ QA Incharge ]",
                            "id": "3033"
                        },
                        {
                            "tdesc": "QA-Incharge",
                            "edesc": "QA-Incharge",
                            "id": "3034"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ PQC ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ PQC ]",
                            "id": "3035"
                        },
                        {
                            "tdesc": "PQC.",
                            "edesc": "PQC.",
                            "id": "3036"
                        },
                        {
                            "tdesc": "MG,AM ,Specialist  [QA. Testroom]",
                            "edesc": "MG,AM ,Specialist  [QA. Testroom]",
                            "id": "3041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [QA. Testroom]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [QA. Testroom]",
                            "id": "3042"
                        },
                        {
                            "tdesc": "QA.-Test room",
                            "edesc": "QA.-Test room",
                            "id": "3043"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [Global test]",
                            "edesc": "MG,AM,Specialist [Global test]",
                            "id": "3044"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Global test]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Global test]",
                            "id": "3045"
                        },
                        {
                            "tdesc": "Global test",
                            "edesc": "Global test",
                            "id": "3046"
                        },
                        {
                            "tdesc": "Senior Specialist, Specialist [ Project Engineer]",
                            "edesc": "Senior Specialist, Specialist [ Project Engineer]",
                            "id": "3051"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Project  Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Project  Engineer]",
                            "id": "3052"
                        },
                        {
                            "tdesc": "Project Engineer",
                            "edesc": "Project Engineer",
                            "id": "3053"
                        },
                        {
                            "tdesc": "MG,Senior Specialist /Specialist [M/N]",
                            "edesc": "MG,Senior Specialist /Specialist [M/N]",
                            "id": "3054"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [  M/N]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [  M/N]",
                            "id": "3055"
                        },
                        {
                            "tdesc": "Maintenance",
                            "edesc": "Maintenance",
                            "id": "3056"
                        },
                        {
                            "tdesc": "Japanese [PD.2]",
                            "edesc": "Japanese [PD.2]",
                            "id": "3061"
                        },
                        {
                            "tdesc": "OO,GM,MG,AM,SS,Specialist [PC.]",
                            "edesc": "OO,GM,MG,AM,SS,Specialist [PC.]",
                            "id": "3062"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ PC.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ PC.]",
                            "id": "3063"
                        },
                        {
                            "tdesc": "Production Control",
                            "edesc": "Production Control",
                            "id": "3064"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I/D.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I/D.]",
                            "id": "3065"
                        },
                        {
                            "tdesc": "Incoming Delivery",
                            "edesc": "Incoming Delivery",
                            "id": "3066"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ D/L.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ D/L.]",
                            "id": "3067"
                        },
                        {
                            "tdesc": "Delivery&Logistic",
                            "edesc": "Delivery&Logistic",
                            "id": "3068"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Material Purchasing]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Material Purchasing]",
                            "id": "3069"
                        },
                        {
                            "tdesc": "Material Purchasing",
                            "edesc": "Material Purchasing",
                            "id": "3070"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist [ Mixing Engineer]",
                            "edesc": "S-MG,MG,AM,Specialist [ Mixing Engineer]",
                            "id": "3071"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ Mixing Engineer ]",
                            "edesc": "Chief,A-Chief [ Mixing Engineer ]",
                            "id": "3072"
                        },
                        {
                            "tdesc": "Mixing Engineer",
                            "edesc": "Mixing Engineer",
                            "id": "3073"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ ITRD]",
                            "edesc": "MG,AM,Specialist [ ITRD]",
                            "id": "3080"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ITRD]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ITRD]",
                            "id": "3081"
                        },
                        {
                            "tdesc": "ITRD.",
                            "edesc": "ITRD.",
                            "id": "3082"
                        },
                        {
                            "tdesc": "Japanese Kaizen",
                            "edesc": "Japanese Kaizen",
                            "id": "3083"
                        },
                        {
                            "tdesc": "NTCS",
                            "edesc": "NTCS",
                            "id": "3084"
                        },
                        {
                            "tdesc": "Senior Specialist, AM [ Kaizen]",
                            "edesc": "Senior Specialist, AM [ Kaizen]",
                            "id": "3091"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ KAIZEN  & Master ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ KAIZEN  & Master ]",
                            "id": "3092"
                        },
                        {
                            "tdesc": "KAIZEN-1",
                            "edesc": "KAIZEN-1",
                            "id": "3093"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "id": "3094"
                        },
                        {
                            "tdesc": "Instructor",
                            "edesc": "Instructor",
                            "id": "3095"
                        },
                        {
                            "tdesc": "AM [ Kaizen ]",
                            "edesc": "AM [ Kaizen ]",
                            "id": "3096"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ Instructor ]",
                            "edesc": "MG,AM,Specialist [ Instructor ]",
                            "id": "3111"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "id": "3112"
                        },
                        {
                            "tdesc": "Instructor",
                            "edesc": "Instructor",
                            "id": "3113"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead[ DCC .Center ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead[ DCC .Center ]",
                            "id": "3114"
                        },
                        {
                            "tdesc": "DCC .Center",
                            "edesc": "DCC .Center",
                            "id": "3115"
                        },
                        {
                            "tdesc": "Shipping",
                            "edesc": "Shipping",
                            "id": "3402"
                        },
                        {
                            "tdesc": "G/R (GSN) (Day)",
                            "edesc": "G/R (GSN) Day)",
                            "id": "3506"
                        },
                        {
                            "tdesc": "STOCK&ANNEL-1",
                            "edesc": "NULL",
                            "id": "3520"
                        },
                        {
                            "tdesc": "NONE FINISHING",
                            "edesc": "NON FINISHING",
                            "id": "3522"
                        },
                        {
                            "tdesc": "Engineer Die",
                            "edesc": "Engineer Die",
                            "id": "3523"
                        },
                        {
                            "tdesc": "Mold&Prototype",
                            "edesc": "Mold&Prototype",
                            "id": "3525"
                        },
                        {
                            "tdesc": "Process Engineer",
                            "edesc": "Process Engineer",
                            "id": "3526"
                        },
                        {
                            "tdesc": "Engineer Process",
                            "edesc": "Engineer Process",
                            "id": "3535"
                        },
                        {
                            "tdesc": "Engineer Project",
                            "edesc": "Engineer Project",
                            "id": "3536"
                        },
                        {
                            "tdesc": "VP,OO,GM,SMG,MG,AM,S[ Production 1 ]",
                            "edesc": "VP,OO,GM,SMG,MG,AM,S[ Production 1 ]",
                            "id": "4011"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MA - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MA - 1 ]",
                            "id": "4012"
                        },
                        {
                            "tdesc": "MA-1",
                            "edesc": "MA-1",
                            "id": "4013"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MA- 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MA- 2 ]",
                            "id": "4014"
                        },
                        {
                            "tdesc": "MA-2",
                            "edesc": "MA-2",
                            "id": "4015"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 1 ]",
                            "id": "4016"
                        },
                        {
                            "tdesc": "MB-1",
                            "edesc": "MB-1",
                            "id": "4017"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 2 ]",
                            "id": "4018"
                        },
                        {
                            "tdesc": "MB-2",
                            "edesc": "MB-2",
                            "id": "4019"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 1 ]",
                            "id": "4020"
                        },
                        {
                            "tdesc": "MC-1",
                            "edesc": "MC-1",
                            "id": "4021"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 2 ]",
                            "id": "4022"
                        },
                        {
                            "tdesc": "MC-2",
                            "edesc": "MC-2",
                            "id": "4023"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 1 ]",
                            "id": "4024"
                        },
                        {
                            "tdesc": "MD-1",
                            "edesc": "MD-1",
                            "id": "4025"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 2 ]",
                            "id": "4026"
                        },
                        {
                            "tdesc": "MD-2",
                            "edesc": "MD-2",
                            "id": "4027"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 1 ]",
                            "id": "4028"
                        },
                        {
                            "tdesc": "ME-1",
                            "edesc": "ME-1",
                            "id": "4029"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 2 ]",
                            "id": "4030"
                        },
                        {
                            "tdesc": "ME-2",
                            "edesc": "ME-2",
                            "id": "4031"
                        },
                        {
                            "tdesc": "DCC . Production 1",
                            "edesc": "DCC . Production 1",
                            "id": "4032"
                        },
                        {
                            "tdesc": "MG,AM [ Production 2 ]",
                            "edesc": "MG,AM [ Production 2 ]",
                            "id": "4033"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-1 ]",
                            "id": "4034"
                        },
                        {
                            "tdesc": "Inspection-1",
                            "edesc": "Inspection-1",
                            "id": "4035"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-2 ]",
                            "id": "4036"
                        },
                        {
                            "tdesc": "Inspection-2",
                            "edesc": "Inspection-2",
                            "id": "4037"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -1 ]",
                            "id": "4038"
                        },
                        {
                            "tdesc": "Extrusion-1",
                            "edesc": "Extrusion-1",
                            "id": "4039"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -2 ]",
                            "id": "4040"
                        },
                        {
                            "tdesc": "Extrusion-2",
                            "edesc": "Extrusion-2",
                            "id": "4041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 1  ]",
                            "id": "4042"
                        },
                        {
                            "tdesc": "Extrude A-1",
                            "edesc": "Extrude A-1",
                            "id": "4043"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 2  ]",
                            "id": "4044"
                        },
                        {
                            "tdesc": "Extrude A-2",
                            "edesc": "Extrude A-2",
                            "id": "4045"
                        },
                        {
                            "tdesc": "Chief, A-Chief, Leader,Sub Lead [B Line-1]",
                            "edesc": "Chief, A-Chief, Leader,Sub Lead [B Line-1]",
                            "id": "4046"
                        },
                        {
                            "tdesc": "Extrude B-1",
                            "edesc": "Extrude B-1",
                            "id": "4047"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [B Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [B Line-2]",
                            "id": "4048"
                        },
                        {
                            "tdesc": "Extrude B-2",
                            "edesc": "Extrude B-2",
                            "id": "4049"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [C Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [C Line-1]",
                            "id": "4050"
                        },
                        {
                            "tdesc": "Extrude C-1",
                            "edesc": "Extrude C-1",
                            "id": "4051"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [C Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [C Line-2]",
                            "id": "4052"
                        },
                        {
                            "tdesc": "Extrude C-2",
                            "edesc": "Extrude C-2",
                            "id": "4053"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [D Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [D Line-1]",
                            "id": "4054"
                        },
                        {
                            "tdesc": "Extrude D-1",
                            "edesc": "Extrude D-1",
                            "id": "4055"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [D Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [D Line-2]",
                            "id": "4056"
                        },
                        {
                            "tdesc": "Extrude D-2",
                            "edesc": "Extrude D-2",
                            "id": "4057"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [E Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [E Line-1]",
                            "id": "4058"
                        },
                        {
                            "tdesc": "Extrude E-1",
                            "edesc": "Extrude E-1",
                            "id": "4059"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ E-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ E-Line 2  ]",
                            "id": "4060"
                        },
                        {
                            "tdesc": "Extrude E-2",
                            "edesc": "Extrude E-2",
                            "id": "4061"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 1  ]",
                            "id": "4062"
                        },
                        {
                            "tdesc": "Extrude F-1",
                            "edesc": "Extrude F-1",
                            "id": "4063"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 2  ]",
                            "id": "4064"
                        },
                        {
                            "tdesc": "Extrude F-2",
                            "edesc": "Extrude F-2",
                            "id": "4065"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 1  ]",
                            "id": "4066"
                        },
                        {
                            "tdesc": "Extrude G-1",
                            "edesc": "Extrude G-1",
                            "id": "4067"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 2  ]",
                            "id": "4068"
                        },
                        {
                            "tdesc": "Extrude G-2",
                            "edesc": "Extrude G-2",
                            "id": "4069"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 1  ]",
                            "id": "4070"
                        },
                        {
                            "tdesc": "Extrude H-1",
                            "edesc": "Extrude H-1",
                            "id": "4071"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 2  ]",
                            "id": "4072"
                        },
                        {
                            "tdesc": "Extrude H-2",
                            "edesc": "Extrude H-2",
                            "id": "4073"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 1 ]",
                            "id": "4074"
                        },
                        {
                            "tdesc": "Metal line & Silicone - 1",
                            "edesc": "Metal line & Silicone - 1",
                            "id": "4075"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 2 ]",
                            "id": "4076"
                        },
                        {
                            "tdesc": "Matel Line & Silicone - 2",
                            "edesc": "Matel Line & Silicone - 2",
                            "id": "4077"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 1 ]",
                            "id": "4078"
                        },
                        {
                            "tdesc": "Silicone-1",
                            "edesc": "Silicone-1",
                            "id": "4079"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 2 ]",
                            "id": "4080"
                        },
                        {
                            "tdesc": "Silicone-2",
                            "edesc": "Silicone-2",
                            "id": "4081"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -1]",
                            "id": "4082"
                        },
                        {
                            "tdesc": "Stock Profile - 1",
                            "edesc": "Stock Profile - 1",
                            "id": "4083"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -2]",
                            "id": "4084"
                        },
                        {
                            "tdesc": "Stock Profile - 2",
                            "edesc": "Stock Profile - 2",
                            "id": "4085"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 1]",
                            "id": "4086"
                        },
                        {
                            "tdesc": "Annealing Profile - 1",
                            "edesc": "Annealing Profile - 1",
                            "id": "4087"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 2]",
                            "id": "4088"
                        },
                        {
                            "tdesc": "Annealing Profile -2",
                            "edesc": "Annealing Profile -2",
                            "id": "4089"
                        },
                        {
                            "tdesc": "DCC .Production 2/Support",
                            "edesc": "DCC .Production 2/Support",
                            "id": "4090"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 1]",
                            "id": "4091"
                        },
                        {
                            "tdesc": "R-RAIL-1",
                            "edesc": "R-RAIL-1",
                            "id": "4092"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 2]",
                            "id": "4093"
                        },
                        {
                            "tdesc": "R-RAIL-2",
                            "edesc": "R-RAIL-2",
                            "id": "4094"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [(G/R  [GSN])-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [(G/R  [GSN])-1]",
                            "id": "4095"
                        },
                        {
                            "tdesc": "G/R (GSN)-1",
                            "edesc": "G/R (GSN)-1",
                            "id": "4096"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [G/R  [GSN]-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [G/R  [GSN]-2]",
                            "id": "4097"
                        },
                        {
                            "tdesc": "G/R (GSN)-2",
                            "edesc": "G/R (GSN)-2",
                            "id": "4098"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-1 ]",
                            "id": "4099"
                        },
                        {
                            "tdesc": "FRI -1",
                            "edesc": "FRI -1",
                            "id": "4100"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-2 ]",
                            "id": "4101"
                        },
                        {
                            "tdesc": "FRI -2",
                            "edesc": "FRI -2",
                            "id": "4102"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Injection -1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Injection -1 ]",
                            "id": "4103"
                        },
                        {
                            "tdesc": "INJECTION -1",
                            "edesc": "INJECTION -1",
                            "id": "4104"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Injection -2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Injection -2 ]",
                            "id": "4105"
                        },
                        {
                            "tdesc": "INJECTION -2",
                            "edesc": "INJECTION -2",
                            "id": "4106"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-1 ]",
                            "id": "4107"
                        },
                        {
                            "tdesc": "FRO 1-1",
                            "edesc": "FRO 1-1",
                            "id": "4108"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-2 ]",
                            "id": "4109"
                        },
                        {
                            "tdesc": "FRO 1-2",
                            "edesc": "FRO 1-2",
                            "id": "4110"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-1 ]",
                            "id": "4111"
                        },
                        {
                            "tdesc": "FRO 2-1",
                            "edesc": "FRO 2-1",
                            "id": "4112"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-2 ]",
                            "id": "4113"
                        },
                        {
                            "tdesc": "FRO 2-2",
                            "edesc": "FRO 2-2",
                            "id": "4114"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-1 ]",
                            "id": "4115"
                        },
                        {
                            "tdesc": "FRO 3-1",
                            "edesc": "FRO 3-1",
                            "id": "4116"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-2 ]",
                            "id": "4117"
                        },
                        {
                            "tdesc": "FRO 3-2",
                            "edesc": "FRO 3-2",
                            "id": "4118"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-1 ]",
                            "id": "4119"
                        },
                        {
                            "tdesc": "FRO 4-1",
                            "edesc": "FRO 4-1",
                            "id": "4120"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-2 ]",
                            "id": "4121"
                        },
                        {
                            "tdesc": "FRO 4-2",
                            "edesc": "FRO 4-2",
                            "id": "4122"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-1 ]",
                            "id": "4123"
                        },
                        {
                            "tdesc": "FRO 5-1",
                            "edesc": "FRO 5-1",
                            "id": "4124"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-2 ]",
                            "id": "4125"
                        },
                        {
                            "tdesc": "FRO 5-2",
                            "edesc": "FRO 5-2",
                            "id": "4126"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-1 ]",
                            "id": "4127"
                        },
                        {
                            "tdesc": "FRO 6-1",
                            "edesc": "FRO 6-1",
                            "id": "4128"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-2 ]",
                            "id": "4129"
                        },
                        {
                            "tdesc": "FRO 6-2",
                            "edesc": "FRO 6-2",
                            "id": "4130"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-1 ]",
                            "id": "4131"
                        },
                        {
                            "tdesc": "FRO 7-1",
                            "edesc": "FRO 7-1",
                            "id": "4132"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-2 ]",
                            "id": "4133"
                        },
                        {
                            "tdesc": "FRO 7-2",
                            "edesc": "FRO 7-2",
                            "id": "4134"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-1 ]",
                            "id": "4135"
                        },
                        {
                            "tdesc": "FRO 8-1",
                            "edesc": "FRO 8-1",
                            "id": "4136"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-2 ]",
                            "id": "4137"
                        },
                        {
                            "tdesc": "FRO 8-2",
                            "edesc": "FRO 8-2",
                            "id": "4138"
                        },
                        {
                            "tdesc": "GM,MG,AM [Production 3]",
                            "edesc": "GM,MG,AM [Production 3]",
                            "id": "4139"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-1/1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-1/1]",
                            "id": "4140"
                        },
                        {
                            "tdesc": "No Mold 3-1/1",
                            "edesc": "No Mold 3-1/1",
                            "id": "4141"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-1/2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-1/2]",
                            "id": "4142"
                        },
                        {
                            "tdesc": "No Mold 3-1/2",
                            "edesc": "No Mold 3-1/2",
                            "id": "4143"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Clip -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Clip -1]",
                            "id": "4144"
                        },
                        {
                            "tdesc": "CLIP -1",
                            "edesc": "CLIP -1",
                            "id": "4145"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Clip -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Clip -2]",
                            "id": "4146"
                        },
                        {
                            "tdesc": "CLIP -2",
                            "edesc": "CLIP -2",
                            "id": "4147"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Dango]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Dango]",
                            "id": "4148"
                        },
                        {
                            "tdesc": "Dango",
                            "edesc": "Dango",
                            "id": "4149"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Part  Service]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Part  Service]",
                            "id": "4150"
                        },
                        {
                            "tdesc": "Part Service-1",
                            "edesc": "Part Service-1",
                            "id": "4151"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-1]",
                            "id": "4152"
                        },
                        {
                            "tdesc": "Relieve3/1-1",
                            "edesc": "Relieve3/1-1",
                            "id": "4153"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-2]",
                            "id": "4154"
                        },
                        {
                            "tdesc": "Relieve3/1-2",
                            "edesc": "Relieve3/1-2",
                            "id": "4155"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/2-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/2-1]",
                            "id": "4156"
                        },
                        {
                            "tdesc": "Relieve3/2-1",
                            "edesc": "Relieve3/2-1",
                            "id": "4157"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve3/2-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve3/2-2]",
                            "id": "4158"
                        },
                        {
                            "tdesc": "Relieve3/2-2",
                            "edesc": "Relieve3/2-2",
                            "id": "4159"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 1]",
                            "id": "4160"
                        },
                        {
                            "tdesc": "TPE-1",
                            "edesc": "TPE-1",
                            "id": "4161"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 2]",
                            "id": "4162"
                        },
                        {
                            "tdesc": "TPE- 2",
                            "edesc": "TPE- 2",
                            "id": "4163"
                        },
                        {
                            "tdesc": "Japan",
                            "edesc": "Japan",
                            "id": "4164"
                        },
                        {
                            "tdesc": "New Associate",
                            "edesc": "New Associate",
                            "id": "4165"
                        },
                        {
                            "tdesc": "PREGNANT(BABY)",
                            "edesc": "PREGNANT(BABY)",
                            "id": "4166"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -1]",
                            "id": "4167"
                        },
                        {
                            "tdesc": "Final  Inspection -1",
                            "edesc": "Final  Inspection -1",
                            "id": "4168"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -2]",
                            "id": "4169"
                        },
                        {
                            "tdesc": "Final  Inspection -2",
                            "edesc": "Final  Inspection -2",
                            "id": "4170"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 1 ]",
                            "id": "4171"
                        },
                        {
                            "tdesc": "Silicone/Pro3 - 1",
                            "edesc": "Silicone/Pro3 - 1",
                            "id": "4172"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 2 ]",
                            "id": "4173"
                        },
                        {
                            "tdesc": "Silicone/Pro3 - 2",
                            "edesc": "Silicone/Pro3 - 2",
                            "id": "4174"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ Production Planning ]",
                            "edesc": "MG,AM,Specialist [ Production Planning ]",
                            "id": "4175"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Production Planning   ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Production Planning   ]",
                            "id": "4176"
                        },
                        {
                            "tdesc": "Production Planning",
                            "edesc": "Production Planning",
                            "id": "4177"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 1  ]",
                            "id": "4178"
                        },
                        {
                            "tdesc": "GPC - 1",
                            "edesc": "GPC - 1",
                            "id": "4179"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 2  ]",
                            "id": "4180"
                        },
                        {
                            "tdesc": "GPC - 2",
                            "edesc": "GPC - 2",
                            "id": "4181"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-2/1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-2/1]",
                            "id": "4182"
                        },
                        {
                            "tdesc": "No Mold 3-2/1",
                            "edesc": "No Mold 3-2/1",
                            "id": "4183"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-2/2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-2/2]",
                            "id": "4184"
                        },
                        {
                            "tdesc": "No Mold 3-2/2",
                            "edesc": "No Mold 3-2/2",
                            "id": "4185"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 1  ]",
                            "id": "4186"
                        },
                        {
                            "tdesc": "Extrude I-1",
                            "edesc": "Extrude I-1",
                            "id": "4187"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 2  ]",
                            "id": "4188"
                        },
                        {
                            "tdesc": "Extrude I-2",
                            "edesc": "Extrude I-2",
                            "id": "4189"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-1 ]",
                            "id": "4190"
                        },
                        {
                            "tdesc": "FRO 9-1",
                            "edesc": "FRO 9-1",
                            "id": "4191"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-2 ]",
                            "id": "4192"
                        },
                        {
                            "tdesc": "FRO 9-2",
                            "edesc": "FRO 9-2",
                            "id": "4193"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-1 ]",
                            "id": "4194"
                        },
                        {
                            "tdesc": "FRI2-1",
                            "edesc": "FRI2-1",
                            "id": "4195"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-2 ]",
                            "id": "4196"
                        },
                        {
                            "tdesc": "FRI2-2",
                            "edesc": "FRI2-2",
                            "id": "4197"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor1-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor1-1]",
                            "id": "4198"
                        },
                        {
                            "tdesc": "Conveyor1-1",
                            "edesc": "Conveyor1-1",
                            "id": "4199"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyo1-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyo1-2]",
                            "id": "4200"
                        },
                        {
                            "tdesc": "Conveyor1-2",
                            "edesc": "Conveyor1-2",
                            "id": "4201"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-1]",
                            "id": "4202"
                        },
                        {
                            "tdesc": "Conveyor2-1",
                            "edesc": "Conveyor2-1",
                            "id": "4203"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-2]",
                            "id": "4204"
                        },
                        {
                            "tdesc": "Conveyor2-2",
                            "edesc": "Conveyor2-2",
                            "id": "4205"
                        },
                        {
                            "tdesc": "Extrude I-2",
                            "edesc": "Extrude I-2",
                            "id": "4819"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "sasi"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "test"
                        }
                    ],
                    "variableName": "bu3_begin"
                },
                "bu3_end": {
                    "label": "bu3 stop",
                    "option": "mbu3help|__bu3_end:mbu3.bu3id",
                    "table": "mbu3",
                    "type": "help",
                    "value": "xxxxxxxxxx",
                    "valueDefault": "xxxxxxxxxx",
                    "valueDetail": [
                        {
                            "tdesc": "NONE",
                            "edesc": "NONE",
                            "id": "00"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "1011"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "10111"
                        },
                        {
                            "tdesc": "GM/SMG/MG/AM [ Admin ]",
                            "edesc": "GM/SMG/MG/AM [ Admin ]",
                            "id": "1012"
                        },
                        {
                            "tdesc": "Chief,A-Chief [HR]",
                            "edesc": "Chief,A-Chief [HR]",
                            "id": "1013"
                        },
                        {
                            "tdesc": "HR",
                            "edesc": "HR",
                            "id": "1014"
                        },
                        {
                            "tdesc": "Interpretor",
                            "edesc": "Interpretor",
                            "id": "1015"
                        },
                        {
                            "tdesc": "Driver [ HR]",
                            "edesc": "Driver [ HR]",
                            "id": "1016"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist[Safety]",
                            "edesc": "S-MG,MG,AM,Specialist[Safety]",
                            "id": "1017"
                        },
                        {
                            "tdesc": "Chief,A-Chief [Safety]",
                            "edesc": "Chief,A-Chief [Safety]",
                            "id": "1018"
                        },
                        {
                            "tdesc": "Safety",
                            "edesc": "Safety",
                            "id": "1019"
                        },
                        {
                            "tdesc": "MG,AM,Specialist  [G.A./QCC,Training Center]",
                            "edesc": "MG,AM,Specialist  [G.A./QCC,Training Center]",
                            "id": "1020"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [G.A./QCC,Training Center]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [G.A./QCC,Training Center]",
                            "id": "1021"
                        },
                        {
                            "tdesc": "G.A./QCC,Training Center",
                            "edesc": "G.A./QCC,Training Center",
                            "id": "1022"
                        },
                        {
                            "tdesc": "Japanese  [ Cad  Design ]",
                            "edesc": "Japanese  [ Cad  Design ]",
                            "id": "1023"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [Cad  Design]",
                            "edesc": "MG,AM,Specialist [Cad  Design]",
                            "id": "1024"
                        },
                        {
                            "tdesc": "Chief,A-Chief, [Cad  Design]",
                            "edesc": "Chief,A-Chief, [Cad  Design]",
                            "id": "1025"
                        },
                        {
                            "tdesc": "CAD Design",
                            "edesc": "CAD Design",
                            "id": "1026"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist  [ Purchase ]",
                            "edesc": "S-MG,MG,AM,Specialist  [ Purchase ]",
                            "id": "1031"
                        },
                        {
                            "tdesc": "Chief,A-Chief [Purchase]",
                            "edesc": "Chief,A-Chief [Purchase]",
                            "id": "1032"
                        },
                        {
                            "tdesc": "Purchase",
                            "edesc": "Purchase",
                            "id": "1033"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [BOI./J-SOX]",
                            "edesc": "MG,AM,Specialist [BOI./J-SOX]",
                            "id": "1034"
                        },
                        {
                            "tdesc": "Chief,A-Chief [BOI./J-SOX]",
                            "edesc": "Chief,A-Chief [BOI./J-SOX]",
                            "id": "1035"
                        },
                        {
                            "tdesc": "BOI./J-SOX",
                            "edesc": "BOI./J-SOX",
                            "id": "1036"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ISO 14001]",
                            "edesc": "Chief,A-Chief [ISO 14001]",
                            "id": "1037"
                        },
                        {
                            "tdesc": "ISO 14001 , นิติกร",
                            "edesc": "ISO 14001 , Lawyer",
                            "id": "1038"
                        },
                        {
                            "tdesc": "AM,Senior  Specialist /Specialist[ Accounting ]",
                            "edesc": "AM,Senior  Specialist /Specialist[ Accounting ]",
                            "id": "1041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Accounting]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Accounting]",
                            "id": "1042"
                        },
                        {
                            "tdesc": "Account",
                            "edesc": "Account",
                            "id": "1043"
                        },
                        {
                            "tdesc": "ทดสอบ",
                            "edesc": "TEST",
                            "id": "123"
                        },
                        {
                            "tdesc": "Japanese  [ Sales ]",
                            "edesc": "Japanese  [ Sales ]",
                            "id": "2011"
                        },
                        {
                            "tdesc": "OO,GM,MG,AM,Specialist  [Sales]",
                            "edesc": "OO,,MG,AM,Specialist  [Sales]",
                            "id": "2012"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ Sales]",
                            "edesc": "Chief,A-Chief [ Sales]",
                            "id": "2013"
                        },
                        {
                            "tdesc": "SALES",
                            "edesc": "SALES",
                            "id": "2014"
                        },
                        {
                            "tdesc": "Driver [Sales]",
                            "edesc": "Driver [Sales]",
                            "id": "2015"
                        },
                        {
                            "tdesc": "Patrol Line",
                            "edesc": "Patrol Line",
                            "id": "300047"
                        },
                        {
                            "tdesc": "QCC. & NPS.",
                            "edesc": "QCC. & NPS.",
                            "id": "300049"
                        },
                        {
                            "tdesc": "Japanese [Engineer]",
                            "edesc": "Japanese [Engineer]",
                            "id": "3010"
                        },
                        {
                            "tdesc": "AM/Specialist [ Die Engineer ]",
                            "edesc": "AM/Specialist [ Die Engineer ]",
                            "id": "3011"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Die Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Die Engineer]",
                            "id": "3012"
                        },
                        {
                            "tdesc": "Die Engineer",
                            "edesc": "Die Engineer",
                            "id": "3013"
                        },
                        {
                            "tdesc": "MG/Specialist [Mold Engineer]",
                            "edesc": "MG/Specialist [Mold Engineer]",
                            "id": "3014"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Mold Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Mold Engineer]",
                            "id": "3015"
                        },
                        {
                            "tdesc": "Mold Engineer",
                            "edesc": "Mold Engineer",
                            "id": "3016"
                        },
                        {
                            "tdesc": "MG [IE Engineer]",
                            "edesc": "MG [IE Engineer]",
                            "id": "3020"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ IE Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ IE Engineer]",
                            "id": "3021"
                        },
                        {
                            "tdesc": "IE Engineer",
                            "edesc": "IE Engineer",
                            "id": "3022"
                        },
                        {
                            "tdesc": "OO,GM, MG [Sales Enginrre & APQP]",
                            "edesc": "OO,GM, MG [Sales Enginrre & APQP]",
                            "id": "3023"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ APQP.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ APQP.]",
                            "id": "3024"
                        },
                        {
                            "tdesc": "Sales Engineer & APQP",
                            "edesc": "Sales Engineer & APQP",
                            "id": "3025"
                        },
                        {
                            "tdesc": "Japanese [QA.]",
                            "edesc": "Japanese [QA.]",
                            "id": "3031"
                        },
                        {
                            "tdesc": "Part Service-2",
                            "edesc": "Part Service-2",
                            "id": "303108"
                        },
                        {
                            "tdesc": "Non Finishing-2",
                            "edesc": "Non Finishing-2",
                            "id": "303110"
                        },
                        {
                            "tdesc": "IE and Kaizen team - 2",
                            "edesc": "IE and Kaizen team - 2",
                            "id": "303117"
                        },
                        {
                            "tdesc": "Senior MG,  AM, Specialist [QA./TS.16949]",
                            "edesc": "Senior MG,  AM, Specialist [QA./TS.16949]",
                            "id": "3032"
                        },
                        {
                            "tdesc": "Production standard cost center (PSC)",
                            "edesc": "Production standard cost center (PSC)",
                            "id": "303201"
                        },
                        {
                            "tdesc": "Fix asset Control",
                            "edesc": "Fix asset Control",
                            "id": "303202"
                        },
                        {
                            "tdesc": "New model lunch up schedule (Lead APQP) Eguiment & Tool Purchase Gr.",
                            "edesc": "New model lunch up schedule (Lead APQP) Eguiment & Tool Purchase Gr.",
                            "id": "303203"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ QA Incharge ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ QA Incharge ]",
                            "id": "3033"
                        },
                        {
                            "tdesc": "QA-Incharge",
                            "edesc": "QA-Incharge",
                            "id": "3034"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ PQC ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ PQC ]",
                            "id": "3035"
                        },
                        {
                            "tdesc": "PQC.",
                            "edesc": "PQC.",
                            "id": "3036"
                        },
                        {
                            "tdesc": "MG,AM ,Specialist  [QA. Testroom]",
                            "edesc": "MG,AM ,Specialist  [QA. Testroom]",
                            "id": "3041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [QA. Testroom]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [QA. Testroom]",
                            "id": "3042"
                        },
                        {
                            "tdesc": "QA.-Test room",
                            "edesc": "QA.-Test room",
                            "id": "3043"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [Global test]",
                            "edesc": "MG,AM,Specialist [Global test]",
                            "id": "3044"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Global test]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Global test]",
                            "id": "3045"
                        },
                        {
                            "tdesc": "Global test",
                            "edesc": "Global test",
                            "id": "3046"
                        },
                        {
                            "tdesc": "Senior Specialist, Specialist [ Project Engineer]",
                            "edesc": "Senior Specialist, Specialist [ Project Engineer]",
                            "id": "3051"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Project  Engineer]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Project  Engineer]",
                            "id": "3052"
                        },
                        {
                            "tdesc": "Project Engineer",
                            "edesc": "Project Engineer",
                            "id": "3053"
                        },
                        {
                            "tdesc": "MG,Senior Specialist /Specialist [M/N]",
                            "edesc": "MG,Senior Specialist /Specialist [M/N]",
                            "id": "3054"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [  M/N]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [  M/N]",
                            "id": "3055"
                        },
                        {
                            "tdesc": "Maintenance",
                            "edesc": "Maintenance",
                            "id": "3056"
                        },
                        {
                            "tdesc": "Japanese [PD.2]",
                            "edesc": "Japanese [PD.2]",
                            "id": "3061"
                        },
                        {
                            "tdesc": "OO,GM,MG,AM,SS,Specialist [PC.]",
                            "edesc": "OO,GM,MG,AM,SS,Specialist [PC.]",
                            "id": "3062"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ PC.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ PC.]",
                            "id": "3063"
                        },
                        {
                            "tdesc": "Production Control",
                            "edesc": "Production Control",
                            "id": "3064"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I/D.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I/D.]",
                            "id": "3065"
                        },
                        {
                            "tdesc": "Incoming Delivery",
                            "edesc": "Incoming Delivery",
                            "id": "3066"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ D/L.]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ D/L.]",
                            "id": "3067"
                        },
                        {
                            "tdesc": "Delivery&Logistic",
                            "edesc": "Delivery&Logistic",
                            "id": "3068"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Material Purchasing]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Material Purchasing]",
                            "id": "3069"
                        },
                        {
                            "tdesc": "Material Purchasing",
                            "edesc": "Material Purchasing",
                            "id": "3070"
                        },
                        {
                            "tdesc": "S-MG,MG,AM,Specialist [ Mixing Engineer]",
                            "edesc": "S-MG,MG,AM,Specialist [ Mixing Engineer]",
                            "id": "3071"
                        },
                        {
                            "tdesc": "Chief,A-Chief [ Mixing Engineer ]",
                            "edesc": "Chief,A-Chief [ Mixing Engineer ]",
                            "id": "3072"
                        },
                        {
                            "tdesc": "Mixing Engineer",
                            "edesc": "Mixing Engineer",
                            "id": "3073"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ ITRD]",
                            "edesc": "MG,AM,Specialist [ ITRD]",
                            "id": "3080"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ITRD]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ITRD]",
                            "id": "3081"
                        },
                        {
                            "tdesc": "ITRD.",
                            "edesc": "ITRD.",
                            "id": "3082"
                        },
                        {
                            "tdesc": "Japanese Kaizen",
                            "edesc": "Japanese Kaizen",
                            "id": "3083"
                        },
                        {
                            "tdesc": "NTCS",
                            "edesc": "NTCS",
                            "id": "3084"
                        },
                        {
                            "tdesc": "Senior Specialist, AM [ Kaizen]",
                            "edesc": "Senior Specialist, AM [ Kaizen]",
                            "id": "3091"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ KAIZEN  & Master ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ KAIZEN  & Master ]",
                            "id": "3092"
                        },
                        {
                            "tdesc": "KAIZEN-1",
                            "edesc": "KAIZEN-1",
                            "id": "3093"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "id": "3094"
                        },
                        {
                            "tdesc": "Instructor",
                            "edesc": "Instructor",
                            "id": "3095"
                        },
                        {
                            "tdesc": "AM [ Kaizen ]",
                            "edesc": "AM [ Kaizen ]",
                            "id": "3096"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ Instructor ]",
                            "edesc": "MG,AM,Specialist [ Instructor ]",
                            "id": "3111"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Instructor ]",
                            "id": "3112"
                        },
                        {
                            "tdesc": "Instructor",
                            "edesc": "Instructor",
                            "id": "3113"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead[ DCC .Center ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead[ DCC .Center ]",
                            "id": "3114"
                        },
                        {
                            "tdesc": "DCC .Center",
                            "edesc": "DCC .Center",
                            "id": "3115"
                        },
                        {
                            "tdesc": "Shipping",
                            "edesc": "Shipping",
                            "id": "3402"
                        },
                        {
                            "tdesc": "G/R (GSN) (Day)",
                            "edesc": "G/R (GSN) Day)",
                            "id": "3506"
                        },
                        {
                            "tdesc": "STOCK&ANNEL-1",
                            "edesc": "NULL",
                            "id": "3520"
                        },
                        {
                            "tdesc": "NONE FINISHING",
                            "edesc": "NON FINISHING",
                            "id": "3522"
                        },
                        {
                            "tdesc": "Engineer Die",
                            "edesc": "Engineer Die",
                            "id": "3523"
                        },
                        {
                            "tdesc": "Mold&Prototype",
                            "edesc": "Mold&Prototype",
                            "id": "3525"
                        },
                        {
                            "tdesc": "Process Engineer",
                            "edesc": "Process Engineer",
                            "id": "3526"
                        },
                        {
                            "tdesc": "Engineer Process",
                            "edesc": "Engineer Process",
                            "id": "3535"
                        },
                        {
                            "tdesc": "Engineer Project",
                            "edesc": "Engineer Project",
                            "id": "3536"
                        },
                        {
                            "tdesc": "VP,OO,GM,SMG,MG,AM,S[ Production 1 ]",
                            "edesc": "VP,OO,GM,SMG,MG,AM,S[ Production 1 ]",
                            "id": "4011"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MA - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MA - 1 ]",
                            "id": "4012"
                        },
                        {
                            "tdesc": "MA-1",
                            "edesc": "MA-1",
                            "id": "4013"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MA- 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MA- 2 ]",
                            "id": "4014"
                        },
                        {
                            "tdesc": "MA-2",
                            "edesc": "MA-2",
                            "id": "4015"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 1 ]",
                            "id": "4016"
                        },
                        {
                            "tdesc": "MB-1",
                            "edesc": "MB-1",
                            "id": "4017"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MB - 2 ]",
                            "id": "4018"
                        },
                        {
                            "tdesc": "MB-2",
                            "edesc": "MB-2",
                            "id": "4019"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 1 ]",
                            "id": "4020"
                        },
                        {
                            "tdesc": "MC-1",
                            "edesc": "MC-1",
                            "id": "4021"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MC - 2 ]",
                            "id": "4022"
                        },
                        {
                            "tdesc": "MC-2",
                            "edesc": "MC-2",
                            "id": "4023"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 1 ]",
                            "id": "4024"
                        },
                        {
                            "tdesc": "MD-1",
                            "edesc": "MD-1",
                            "id": "4025"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ MD - 2 ]",
                            "id": "4026"
                        },
                        {
                            "tdesc": "MD-2",
                            "edesc": "MD-2",
                            "id": "4027"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 1 ]",
                            "id": "4028"
                        },
                        {
                            "tdesc": "ME-1",
                            "edesc": "ME-1",
                            "id": "4029"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ ME - 2 ]",
                            "id": "4030"
                        },
                        {
                            "tdesc": "ME-2",
                            "edesc": "ME-2",
                            "id": "4031"
                        },
                        {
                            "tdesc": "DCC . Production 1",
                            "edesc": "DCC . Production 1",
                            "id": "4032"
                        },
                        {
                            "tdesc": "MG,AM [ Production 2 ]",
                            "edesc": "MG,AM [ Production 2 ]",
                            "id": "4033"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-1 ]",
                            "id": "4034"
                        },
                        {
                            "tdesc": "Inspection-1",
                            "edesc": "Inspection-1",
                            "id": "4035"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Inspect-2 ]",
                            "id": "4036"
                        },
                        {
                            "tdesc": "Inspection-2",
                            "edesc": "Inspection-2",
                            "id": "4037"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -1 ]",
                            "id": "4038"
                        },
                        {
                            "tdesc": "Extrusion-1",
                            "edesc": "Extrusion-1",
                            "id": "4039"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Extrusion -2 ]",
                            "id": "4040"
                        },
                        {
                            "tdesc": "Extrusion-2",
                            "edesc": "Extrusion-2",
                            "id": "4041"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 1  ]",
                            "id": "4042"
                        },
                        {
                            "tdesc": "Extrude A-1",
                            "edesc": "Extrude A-1",
                            "id": "4043"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ A-Line 2  ]",
                            "id": "4044"
                        },
                        {
                            "tdesc": "Extrude A-2",
                            "edesc": "Extrude A-2",
                            "id": "4045"
                        },
                        {
                            "tdesc": "Chief, A-Chief, Leader,Sub Lead [B Line-1]",
                            "edesc": "Chief, A-Chief, Leader,Sub Lead [B Line-1]",
                            "id": "4046"
                        },
                        {
                            "tdesc": "Extrude B-1",
                            "edesc": "Extrude B-1",
                            "id": "4047"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [B Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [B Line-2]",
                            "id": "4048"
                        },
                        {
                            "tdesc": "Extrude B-2",
                            "edesc": "Extrude B-2",
                            "id": "4049"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [C Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [C Line-1]",
                            "id": "4050"
                        },
                        {
                            "tdesc": "Extrude C-1",
                            "edesc": "Extrude C-1",
                            "id": "4051"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [C Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [C Line-2]",
                            "id": "4052"
                        },
                        {
                            "tdesc": "Extrude C-2",
                            "edesc": "Extrude C-2",
                            "id": "4053"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [D Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [D Line-1]",
                            "id": "4054"
                        },
                        {
                            "tdesc": "Extrude D-1",
                            "edesc": "Extrude D-1",
                            "id": "4055"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [D Line-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [D Line-2]",
                            "id": "4056"
                        },
                        {
                            "tdesc": "Extrude D-2",
                            "edesc": "Extrude D-2",
                            "id": "4057"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [E Line-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [E Line-1]",
                            "id": "4058"
                        },
                        {
                            "tdesc": "Extrude E-1",
                            "edesc": "Extrude E-1",
                            "id": "4059"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ E-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ E-Line 2  ]",
                            "id": "4060"
                        },
                        {
                            "tdesc": "Extrude E-2",
                            "edesc": "Extrude E-2",
                            "id": "4061"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 1  ]",
                            "id": "4062"
                        },
                        {
                            "tdesc": "Extrude F-1",
                            "edesc": "Extrude F-1",
                            "id": "4063"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ F-Line 2  ]",
                            "id": "4064"
                        },
                        {
                            "tdesc": "Extrude F-2",
                            "edesc": "Extrude F-2",
                            "id": "4065"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 1  ]",
                            "id": "4066"
                        },
                        {
                            "tdesc": "Extrude G-1",
                            "edesc": "Extrude G-1",
                            "id": "4067"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ G-Line 2  ]",
                            "id": "4068"
                        },
                        {
                            "tdesc": "Extrude G-2",
                            "edesc": "Extrude G-2",
                            "id": "4069"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 1  ]",
                            "id": "4070"
                        },
                        {
                            "tdesc": "Extrude H-1",
                            "edesc": "Extrude H-1",
                            "id": "4071"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ H-Line 2  ]",
                            "id": "4072"
                        },
                        {
                            "tdesc": "Extrude H-2",
                            "edesc": "Extrude H-2",
                            "id": "4073"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 1 ]",
                            "id": "4074"
                        },
                        {
                            "tdesc": "Metal line & Silicone - 1",
                            "edesc": "Metal line & Silicone - 1",
                            "id": "4075"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Matel Line & Silicone - 2 ]",
                            "id": "4076"
                        },
                        {
                            "tdesc": "Matel Line & Silicone - 2",
                            "edesc": "Matel Line & Silicone - 2",
                            "id": "4077"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 1 ]",
                            "id": "4078"
                        },
                        {
                            "tdesc": "Silicone-1",
                            "edesc": "Silicone-1",
                            "id": "4079"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone - 2 ]",
                            "id": "4080"
                        },
                        {
                            "tdesc": "Silicone-2",
                            "edesc": "Silicone-2",
                            "id": "4081"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -1]",
                            "id": "4082"
                        },
                        {
                            "tdesc": "Stock Profile - 1",
                            "edesc": "Stock Profile - 1",
                            "id": "4083"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Stock  Profile -2]",
                            "id": "4084"
                        },
                        {
                            "tdesc": "Stock Profile - 2",
                            "edesc": "Stock Profile - 2",
                            "id": "4085"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 1]",
                            "id": "4086"
                        },
                        {
                            "tdesc": "Annealing Profile - 1",
                            "edesc": "Annealing Profile - 1",
                            "id": "4087"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Annealing Profile - 2]",
                            "id": "4088"
                        },
                        {
                            "tdesc": "Annealing Profile -2",
                            "edesc": "Annealing Profile -2",
                            "id": "4089"
                        },
                        {
                            "tdesc": "DCC .Production 2/Support",
                            "edesc": "DCC .Production 2/Support",
                            "id": "4090"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 1]",
                            "id": "4091"
                        },
                        {
                            "tdesc": "R-RAIL-1",
                            "edesc": "R-RAIL-1",
                            "id": "4092"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ R-RAIL (D/S) - 2]",
                            "id": "4093"
                        },
                        {
                            "tdesc": "R-RAIL-2",
                            "edesc": "R-RAIL-2",
                            "id": "4094"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [(G/R  [GSN])-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [(G/R  [GSN])-1]",
                            "id": "4095"
                        },
                        {
                            "tdesc": "G/R (GSN)-1",
                            "edesc": "G/R (GSN)-1",
                            "id": "4096"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [G/R  [GSN]-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [G/R  [GSN]-2]",
                            "id": "4097"
                        },
                        {
                            "tdesc": "G/R (GSN)-2",
                            "edesc": "G/R (GSN)-2",
                            "id": "4098"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-1 ]",
                            "id": "4099"
                        },
                        {
                            "tdesc": "FRI -1",
                            "edesc": "FRI -1",
                            "id": "4100"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI-2 ]",
                            "id": "4101"
                        },
                        {
                            "tdesc": "FRI -2",
                            "edesc": "FRI -2",
                            "id": "4102"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Injection -1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Injection -1 ]",
                            "id": "4103"
                        },
                        {
                            "tdesc": "INJECTION -1",
                            "edesc": "INJECTION -1",
                            "id": "4104"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Injection -2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Injection -2 ]",
                            "id": "4105"
                        },
                        {
                            "tdesc": "INJECTION -2",
                            "edesc": "INJECTION -2",
                            "id": "4106"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-1 ]",
                            "id": "4107"
                        },
                        {
                            "tdesc": "FRO 1-1",
                            "edesc": "FRO 1-1",
                            "id": "4108"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 1-2 ]",
                            "id": "4109"
                        },
                        {
                            "tdesc": "FRO 1-2",
                            "edesc": "FRO 1-2",
                            "id": "4110"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-1 ]",
                            "id": "4111"
                        },
                        {
                            "tdesc": "FRO 2-1",
                            "edesc": "FRO 2-1",
                            "id": "4112"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 2-2 ]",
                            "id": "4113"
                        },
                        {
                            "tdesc": "FRO 2-2",
                            "edesc": "FRO 2-2",
                            "id": "4114"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-1 ]",
                            "id": "4115"
                        },
                        {
                            "tdesc": "FRO 3-1",
                            "edesc": "FRO 3-1",
                            "id": "4116"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 3-2 ]",
                            "id": "4117"
                        },
                        {
                            "tdesc": "FRO 3-2",
                            "edesc": "FRO 3-2",
                            "id": "4118"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-1 ]",
                            "id": "4119"
                        },
                        {
                            "tdesc": "FRO 4-1",
                            "edesc": "FRO 4-1",
                            "id": "4120"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 4-2 ]",
                            "id": "4121"
                        },
                        {
                            "tdesc": "FRO 4-2",
                            "edesc": "FRO 4-2",
                            "id": "4122"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-1 ]",
                            "id": "4123"
                        },
                        {
                            "tdesc": "FRO 5-1",
                            "edesc": "FRO 5-1",
                            "id": "4124"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 5-2 ]",
                            "id": "4125"
                        },
                        {
                            "tdesc": "FRO 5-2",
                            "edesc": "FRO 5-2",
                            "id": "4126"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-1 ]",
                            "id": "4127"
                        },
                        {
                            "tdesc": "FRO 6-1",
                            "edesc": "FRO 6-1",
                            "id": "4128"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 6-2 ]",
                            "id": "4129"
                        },
                        {
                            "tdesc": "FRO 6-2",
                            "edesc": "FRO 6-2",
                            "id": "4130"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-1 ]",
                            "id": "4131"
                        },
                        {
                            "tdesc": "FRO 7-1",
                            "edesc": "FRO 7-1",
                            "id": "4132"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 7-2 ]",
                            "id": "4133"
                        },
                        {
                            "tdesc": "FRO 7-2",
                            "edesc": "FRO 7-2",
                            "id": "4134"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-1 ]",
                            "id": "4135"
                        },
                        {
                            "tdesc": "FRO 8-1",
                            "edesc": "FRO 8-1",
                            "id": "4136"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 8-2 ]",
                            "id": "4137"
                        },
                        {
                            "tdesc": "FRO 8-2",
                            "edesc": "FRO 8-2",
                            "id": "4138"
                        },
                        {
                            "tdesc": "GM,MG,AM [Production 3]",
                            "edesc": "GM,MG,AM [Production 3]",
                            "id": "4139"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-1/1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-1/1]",
                            "id": "4140"
                        },
                        {
                            "tdesc": "No Mold 3-1/1",
                            "edesc": "No Mold 3-1/1",
                            "id": "4141"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-1/2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-1/2]",
                            "id": "4142"
                        },
                        {
                            "tdesc": "No Mold 3-1/2",
                            "edesc": "No Mold 3-1/2",
                            "id": "4143"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Clip -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Clip -1]",
                            "id": "4144"
                        },
                        {
                            "tdesc": "CLIP -1",
                            "edesc": "CLIP -1",
                            "id": "4145"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Clip -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Clip -2]",
                            "id": "4146"
                        },
                        {
                            "tdesc": "CLIP -2",
                            "edesc": "CLIP -2",
                            "id": "4147"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Dango]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Dango]",
                            "id": "4148"
                        },
                        {
                            "tdesc": "Dango",
                            "edesc": "Dango",
                            "id": "4149"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Part  Service]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Part  Service]",
                            "id": "4150"
                        },
                        {
                            "tdesc": "Part Service-1",
                            "edesc": "Part Service-1",
                            "id": "4151"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-1]",
                            "id": "4152"
                        },
                        {
                            "tdesc": "Relieve3/1-1",
                            "edesc": "Relieve3/1-1",
                            "id": "4153"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/1-2]",
                            "id": "4154"
                        },
                        {
                            "tdesc": "Relieve3/1-2",
                            "edesc": "Relieve3/1-2",
                            "id": "4155"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/2-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve 3/2-1]",
                            "id": "4156"
                        },
                        {
                            "tdesc": "Relieve3/2-1",
                            "edesc": "Relieve3/2-1",
                            "id": "4157"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Relieve3/2-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Relieve3/2-2]",
                            "id": "4158"
                        },
                        {
                            "tdesc": "Relieve3/2-2",
                            "edesc": "Relieve3/2-2",
                            "id": "4159"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 1]",
                            "id": "4160"
                        },
                        {
                            "tdesc": "TPE-1",
                            "edesc": "TPE-1",
                            "id": "4161"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [TPE - 2]",
                            "id": "4162"
                        },
                        {
                            "tdesc": "TPE- 2",
                            "edesc": "TPE- 2",
                            "id": "4163"
                        },
                        {
                            "tdesc": "Japan",
                            "edesc": "Japan",
                            "id": "4164"
                        },
                        {
                            "tdesc": "New Associate",
                            "edesc": "New Associate",
                            "id": "4165"
                        },
                        {
                            "tdesc": "PREGNANT(BABY)",
                            "edesc": "PREGNANT(BABY)",
                            "id": "4166"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -1]",
                            "id": "4167"
                        },
                        {
                            "tdesc": "Final  Inspection -1",
                            "edesc": "Final  Inspection -1",
                            "id": "4168"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Final  Inspection -2]",
                            "id": "4169"
                        },
                        {
                            "tdesc": "Final  Inspection -2",
                            "edesc": "Final  Inspection -2",
                            "id": "4170"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 1 ]",
                            "id": "4171"
                        },
                        {
                            "tdesc": "Silicone/Pro3 - 1",
                            "edesc": "Silicone/Pro3 - 1",
                            "id": "4172"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ Silicone/Pro3 - 2 ]",
                            "id": "4173"
                        },
                        {
                            "tdesc": "Silicone/Pro3 - 2",
                            "edesc": "Silicone/Pro3 - 2",
                            "id": "4174"
                        },
                        {
                            "tdesc": "MG,AM,Specialist [ Production Planning ]",
                            "edesc": "MG,AM,Specialist [ Production Planning ]",
                            "id": "4175"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Production Planning   ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Production Planning   ]",
                            "id": "4176"
                        },
                        {
                            "tdesc": "Production Planning",
                            "edesc": "Production Planning",
                            "id": "4177"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 1  ]",
                            "id": "4178"
                        },
                        {
                            "tdesc": "GPC - 1",
                            "edesc": "GPC - 1",
                            "id": "4179"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [GPC - 2  ]",
                            "id": "4180"
                        },
                        {
                            "tdesc": "GPC - 2",
                            "edesc": "GPC - 2",
                            "id": "4181"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-2/1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold 3-2/1]",
                            "id": "4182"
                        },
                        {
                            "tdesc": "No Mold 3-2/1",
                            "edesc": "No Mold 3-2/1",
                            "id": "4183"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-2/2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [No Mold  3-2/2]",
                            "id": "4184"
                        },
                        {
                            "tdesc": "No Mold 3-2/2",
                            "edesc": "No Mold 3-2/2",
                            "id": "4185"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 1  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 1  ]",
                            "id": "4186"
                        },
                        {
                            "tdesc": "Extrude I-1",
                            "edesc": "Extrude I-1",
                            "id": "4187"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 2  ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ I-Line 2  ]",
                            "id": "4188"
                        },
                        {
                            "tdesc": "Extrude I-2",
                            "edesc": "Extrude I-2",
                            "id": "4189"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-1 ]",
                            "id": "4190"
                        },
                        {
                            "tdesc": "FRO 9-1",
                            "edesc": "FRO 9-1",
                            "id": "4191"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [FRO 9-2 ]",
                            "id": "4192"
                        },
                        {
                            "tdesc": "FRO 9-2",
                            "edesc": "FRO 9-2",
                            "id": "4193"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-1 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-1 ]",
                            "id": "4194"
                        },
                        {
                            "tdesc": "FRI2-1",
                            "edesc": "FRI2-1",
                            "id": "4195"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-2 ]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [ FRI2-2 ]",
                            "id": "4196"
                        },
                        {
                            "tdesc": "FRI2-2",
                            "edesc": "FRI2-2",
                            "id": "4197"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor1-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor1-1]",
                            "id": "4198"
                        },
                        {
                            "tdesc": "Conveyor1-1",
                            "edesc": "Conveyor1-1",
                            "id": "4199"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyo1-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyo1-2]",
                            "id": "4200"
                        },
                        {
                            "tdesc": "Conveyor1-2",
                            "edesc": "Conveyor1-2",
                            "id": "4201"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-1]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-1]",
                            "id": "4202"
                        },
                        {
                            "tdesc": "Conveyor2-1",
                            "edesc": "Conveyor2-1",
                            "id": "4203"
                        },
                        {
                            "tdesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-2]",
                            "edesc": "Chief,A-Chief,Leader,Sub Lead [Conveyor2-2]",
                            "id": "4204"
                        },
                        {
                            "tdesc": "Conveyor2-2",
                            "edesc": "Conveyor2-2",
                            "id": "4205"
                        },
                        {
                            "tdesc": "Extrude I-2",
                            "edesc": "Extrude I-2",
                            "id": "4819"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "sasi"
                        },
                        {
                            "tdesc": "Japanese&Thai [ Admin ]",
                            "edesc": "Japanese&Thai [ Admin ]",
                            "id": "test"
                        }
                    ],
                    "variableName": "bu3_end"
                },
                "date1": {
                    "label": "date start",
                    "option": "",
                    "table": "",
                    "type": "calendar",
                    "value": "01-02-2025",
                    "valueDefault": "04-03-2025",
                    "valueDetail": [],
                    "variableName": "date1"
                },
                "date2": {
                    "label": "date stop",
                    "option": "",
                    "table": "",
                    "type": "calendar",
                    "value": "28-02-2025",
                    "valueDefault": "04-03-2025",
                    "valueDetail": [],
                    "variableName": "date2"
                },
                "date3": {
                    "label": "วันที่เริ่มนับลาพักร้อน",
                    "option": "",
                    "table": "",
                    "type": "calendar",
                    "value": "01-01-2025",
                    "valueDefault": "01-01-2024",
                    "valueDetail": [],
                    "variableName": "date3"
                },
                "salatype": {
                    "label": "พนักงานรายวัน",
                    "option": "customize|01#ใช่,02#ไม่ใช่",
                    "table": "",
                    "type": "radio",
                    "value": "",
                    "valueDefault": "01",
                    "valueDetail": [],
                    "variableName": "salatype"
                },
                "status": {
                    "label": "สถานะ",
                    "option": "customize|1#ยืนยัน(รอโอนทำจ่าย),2#จ่ายแล้ว",
                    "table": "",
                    "type": "list",
                    "value": "",
                    "valueDefault": "1.0",
                    "valueDetail": [],
                    "variableName": "status"
                },
                "year1": {
                    "label": "ทดสอบ text box",
                    "option": "",
                    "table": "",
                    "type": "text",
                    "value": "",
                    "valueDefault": "2025.0",
                    "valueDetail": [],
                    "variableName": "year1"
                }
            }
        }
    }

    changeDate = new Date();
    select: any = {}
    excelReport?: any
    variableSheet: any = []
    loading = false
    loadingExcel = false
    valueDetail = []
    modalDetail: ModalDetail = {
        text: {
            cardHead: '',
            search: [],
            tableHead: []
        }
    }
    keySelect = ""
    searchModal = ""
    page = 1
    pageSize = 10
    constructor(private route: ActivatedRoute,
        private ngbModal: NgbModal,
        private excelReportService: ExcelReportService,
        private cdr: ChangeDetectorRef
    ) {

    }

    ngOnInit(): void {
        this.route.params.subscribe(params => {
            this.getDataExcelReport(params['id'])
        })
    }
    getDataExcelReport(itemId: string) {
        this.loading = true
        this.excelReport = undefined
        this.variableSheet = []
        this.valueDetail = []
        this.excelReportService.getExcelReport(itemId).subscribe((res: any) => {
            this.excelReport = res
            if (this.excelReport.param) {
                Object.entries(this.excelReport.param.variableSheet).forEach(([key, value]) => {
                    const data = value as any
                    if (data.type == 'text') {
                        this.variableSheet.push({
                            ...data, value: data.valueDefault || '', key: key
                        })
                    } else if (data.type == 'list') {
                        this.variableSheet.push({
                            ...data, value: data.valueDefault || '', key: key, option: data.option.split('customize|')[1].split(',').map((x: any) => {
                                const [value, text] = x.split('#')
                                return { value: value || '', text: text || '' }
                            })
                        })
                    } else if (data.type == 'radio') {
                        this.variableSheet.push({
                            ...data, value: data.valueDefault || '', key: key, option: data.option.split('customize|')[1].split(',').map((x: any) => {
                                const [value, text] = x.split('#')
                                return { value: value || '', text: text || '' }
                            })
                        })
                    } else if (data.type == 'help') {
                        this.variableSheet.push({ ...data, value: data.valueDefault ? { id: data.valueDefault, tdesc: data.valueDefault, edesc: data.valueDefault } : { id: "", tdesc: "", edesc: "" }, key: key })
                    } else if (data.type == 'calendar') {
                        this.variableSheet.push({ ...data, value: data.valueDefault || '', key: key })
                        const [d, m, y] = data.valueDefault ? data.valueDefault.split('-').map(Number) : [null, null, null]
                        this.select[key] = y ? new NgbDate(y, m, d) : null
                    }
                })
            }
            this.loading = false
            this.cdr.detectChanges()
        }, (err) => {
            Object.entries(this.data.param.variableSheet).forEach(([key, value]) => {
                const data = value as any
                if (data.type == 'text') {
                    this.variableSheet.push({
                        ...data, value: data.valueDefault || '', key: key
                    })
                } else if (data.type == 'list') {
                    this.variableSheet.push({
                        ...data, value: data.valueDefault || '', key: key, option: data.option.split('customize|')[1].split(',').map((x: any) => {
                            const [value, text] = x.split('#')
                            return { value: value || '', text: text || '' }
                        })
                    })
                } else if (data.type == 'radio') {
                    this.variableSheet.push({
                        ...data, value: data.valueDefault || '', key: key, option: data.option.split('customize|')[1].split(',').map((x: any) => {
                            const [value, text] = x.split('#')
                            return { value: value || '', text: text || '' }
                        })
                    })
                } else if (data.type == 'help') {
                    this.variableSheet.push({ ...data, value: data.valueDefault ? { id: data.valueDefault, tdesc: data.valueDefault, edesc: data.valueDefault } : { id: "", tdesc: "", edesc: "" }, key: key })
                } else if (data.type == 'calendar') {
                    this.variableSheet.push({ ...data, value: data.valueDefault || '', key: key })
                    const [d, m, y] = data.valueDefault ? data.valueDefault.split('-').map(Number) : [null, null, null]
                    this.select[key] = y ? new NgbDate(y, m, d) : null
                }
            })
            this.loading = false
        })
    }

    formatNgbDate(key: string, date?: NgbDate) {
        if (date) {
            const day = String(date.day).padStart(2, '0');
            const month = String(date.month).padStart(2, '0');
            const year = date.year;
            const item = this.variableSheet.find((i: any) => i.key === key);
            if (item) item.value = `${day}-${month}-${year}`
        } else {
            const item = this.variableSheet.find((i: any) => i.key === key);
            if (item) item.value = ''
        }
    }

    openModal(data: any, modal: any) {
        this.searchModal = ''
        this.page = 1
        this.pageSize = 10
        this.valueDetail = data.valueDetail.map((x: any) => ({ id: x.id || '', tdesc: x.tdesc || '', edesc: x.edesc || '' }))
        this.keySelect = data.key
        this.modalDetail = {
            text: {
                cardHead: "Table " + data.table,
                search: ["Table " + data.table],
                tableHead: ['ID', 'detailTH', 'detailENG']
            }
        }
        this.ngbModal.open(modal, { centered: true, size: 'lg' })
    }

    valueDetailFilter() {
        return this.valueDetail.filter((item: any) =>
            item.id.toLowerCase().includes(this.searchModal.toLowerCase()) ||
            item.tdesc.toLowerCase().includes(this.searchModal.toLowerCase()) ||
            item.edesc.toLowerCase().includes(this.searchModal.toLowerCase())
        )
    }

    selectData(data: any) {
        const item = this.variableSheet.find((i: any) => i.key === this.keySelect);
        if (item) item.value = data;
    }

    dowloadExcelReport() {
        this.loadingExcel = true
        const fileName = this.excelReport.param.excelFile
        const param = this.excelReport.param.variableName
        const data = this.variableSheet.map((item: any) => {
            if (item.type == 'help') {
                return "__" + item.key + "=" + item.value.id
            } else if (item.type == 'calendar' || item.type == 'list' || item.type == 'radio' || item.type == 'text') {
                return "__" + item.key + "=" + item.value
            }
            return ""
        }).join('|')
        this.excelReportService.dowloadExcelReport(fileName, param, data).subscribe((res: any) => {
            const blob = new Blob([res], { type: 'application/octet-stream' });
            FileSaver.saveAs(blob, fileName);
            this.loadingExcel = false
            this.cdr.detectChanges()
        }, (err) => {
            this.loadingExcel = false
            this.cdr.detectChanges()
        })
    }
}