import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { TranslateService } from '@ngx-translate/core';
import { Observable } from 'rxjs';
import { environment } from '../../environments/environment';
import { TemplateModel } from '../model/template.model';
import { ModuleModel } from '../model/module.model';

@Injectable({
  providedIn: 'root'
})
export class ExcelReportService {

  constructor(private http: HttpClient,
    private translateService: TranslateService
  ) { }

  getExcelReport(itemId: string): Observable<any> {
    return this.http.get(environment.url + "/irapi/menuitem/" + itemId + '?companyid=eb2f4f30-edaf-11ee-a69a-c7680edc0e47')
  }
  dowloadExcelReport(fileName: string, varname: string, data: string): Observable<any> {
    return this.http.get(environment.url + "/irapi/excel/export-to-excel?companyid=eb2f4f30-edaf-11ee-a69a-c7680edc0e47&fileName=" + fileName + "&param=__varname=" + varname + "|__screen=XLSOPTION|" + data, { responseType: 'blob' })
  }
  getExcelList(): Observable<TemplateModel[]> {
    return this.http.get<TemplateModel[]>("https://hrplus-std.myhr.co.th/plus/template/lists?companyid=eb2f4f30-edaf-11ee-a69a-c7680edc0e47")
  }
  getModuleList(): Observable<ModuleModel[]> {
    return this.http.get<ModuleModel[]>("https://hrplus-std.myhr.co.th/plus/template/lists/module?companyid=eb2f4f30-edaf-11ee-a69a-c7680edc0e47")
  }

  postTemplate(body: {
    templateId: string,
    tname: string,
    ename: string,
    tdesc: string,
    edesc: string,
    module: string
  }) {
    return this.http.post("https://hrplus-std.myhr.co.th/plus/template?companyid=eb2f4f30-edaf-11ee-a69a-c7680edc0e47", body)
  }
}
